#include <iostream>
#include <string>
#include <sstream>
#include <stdlib.h>

// no
//
// ... by Eli Fulkerson.  See http://www.elifulkerson.com for updates
//

/*
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

using namespace std;

int main(int argc, char* argv[]) {

	string input;

	bool always_strip = false;
	bool always_add = false;
	bool toggle = true;
	
	//parse some arguments
	for (int i = 0; i < argc; i++) {

		std::string arg = argv[i];
		
		if (arg == "-a" || arg == "--add" ) {
			always_add = true;
			toggle = false;
		}

		if (arg == "-d" || arg == "--delete" ) {
			always_strip = true;
			toggle = false;
		}

		if (arg == "-t" || arg == "--toggle" ) {
			toggle = true;
		}

		if (arg == "-v" || arg == "--version" ) {
			cout << "no v0.1  8 June 2017" << endl
				 << "by Eli Fulkerson.  See http://www.elifulkerson.com for updates" << endl << flush;
			return 0;
		}

		if (arg == "-h" || arg == "--help" || arg == "--usage" || arg == "-?" || arg == "/?" || arg == "/h") {

			cout << "no takes stdin, and toggles the presense of a leading 'no ' on each line. " << endl;
			cout << endl;
			cout << "cat config.txt |no" << endl;
			cout << endl;
			
			cout << "Options:" << endl
				 << "--toggle : Default behavior, toggle 'no ' on where it is not and vice versa" << endl
				 << "--add    : Always add a 'no' if it isn't present (also -a)" << endl
				 << "--delete : Always strip a 'no ' if it is present (also -d)" << endl << flush;
			return 0;
		}
	}
	
	while (true) {
		getline(cin, input);

		if (!cin) {
			return 0;
		}

		// no text to toggle
		if (input.length()== 0) {
			cout << endl << flush;
			continue;
		}

		if (input.compare(0, 3, "no ")== 0) {
			// we have a leading "no "
			if (toggle || always_strip){
				// strip off the first three characters, cout the rest
				input.erase(0,3);
				cout << input << endl << flush;
				continue;	
			} 
		} else {
			// we do not have a leading "no " here
			if (toggle || always_add) {
				// cout the input, prepended with "no "
				cout << "no " << input << endl << flush;
				continue;	
			}
		}

		// pass it through as is
		cout << input << endl << flush;

	}

	return 0;
}
